/*******************************************************************************
 *	@file			DLSound.h
 *	@brief			DirectX Library
 *
 *	@date			20-Jun-2010(Sun)
 ******************************************************************************/

#ifndef	__DLSOUND_INCLUDE__
#define	__DLSOUND_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include <vector>

using namespace std;

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		DSDEVICE		DLSound.h		"DLSound.h"
 *	@brief		foCX\
 ******************************************************************************/
struct DSDEVICE
{
	DSDEVICE( const LPGUID& lpGuid = NULL,
			  const LPCSTR& lpDesc = NULL,
			  const LPCSTR& lpModule = NULL )
		: m_lpGuid( lpGuid )
		, m_lpDesc( lpDesc )
		, m_lpModule( lpModule )
	{
	}

	//
	LPGUID					m_lpGuid;											//!< GUID
	LPCSTR					m_lpDesc;											//!< foCX
	LPCSTR					m_lpModule;											//!< W[
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLSound		DLSound.h			"DLSound.h"
 *	@brief		CDLSoundNX
 ******************************************************************************/
class CDLSound
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:

// o֐-------------------------------------------------------------------
private:
	static BOOL CALLBACK DSEnumCallback( LPGUID lpGuid,
										 LPCSTR lpcstrDescription,
										 LPCSTR lpcstrModule,
										 LPVOID lpContext );					//!< foCX̗
protected:
public:
	CDLSound( void );
	~CDLSound( void );

	int Init( const SDLParam& SDL );											//!< 
	int End( void );															//!< I

// oϐ-------------------------------------------------------------------
private:
	LPDIRECTSOUND8			m_lpSound;											//!< DirectSound IuWFNg

	HWND					m_hWnd;												//!< EChEnh

	// foCX
	vector< DSDEVICE >		m_vDevice;											//!< foCX
	DSCAPS					m_DSCaps;											//!< foCX̔\
	DWORD					m_dwSpeaker;										//!< Xs[J[\

protected:
public:

};

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLSOUND_INCLUDE__
