/*******************************************************************************
 *	@file			DLDebug.h
 *	@brief			DirectX Library
 *
 *	@date			29-May-2010(Sat)
 ******************************************************************************/

#ifndef	__DLDEBUG_INCLUDE__
#define	__DLDEBUG_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"
#include "DLGraph.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLDebug		DLDebug.h			"DLDebug.h"
 *	@brief		CDLDebugNX
 ******************************************************************************/
class CDLDebug
{
// 萔`---------------------------------------------------------------------
private:
	static const int METER_MAX		= 4;										//!< v
protected:
public:

// o֐-------------------------------------------------------------------
private:
protected:
public:
	CDLDebug( void );
	~CDLDebug( void );

	int Init( const SDLDebug& SDbg );											//!< 
	int End( void );															//!< I

	void Clear( void );															//!< NA
	float Measurement( void );													//!< 

// oϐ-------------------------------------------------------------------
private:
	LARGE_INTEGER			m_lnBase;											//!< v̓y
	LARGE_INTEGER			m_lnMeter[ METER_MAX ];								//!< v
	int						m_nMeterNum;										//!< v
	BOOL					m_bMeterFlag;										//!< vJE^[

protected:
public:

};

// OO[oϐ---------------------------------------------------------

// O֐vg^Cv錾---------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLDEBUG_INCLUDE__
